package solatium.blockchain;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Getter;
import solatium.interfaces.User;

@Getter
public class Transaction {

    private String senderName;
    private String receiverName;
    private int value;

    @JsonCreator
    public Transaction(@JsonProperty("senderName") String senderName, @JsonProperty("receiverName") String receiverName, @JsonProperty("value") int value) {
        this.senderName = senderName;
        this.receiverName = receiverName;
        this.value = value;
    }

    public Transaction(User senderName, User receiverName, int value) {
        this(senderName.getUserName(), receiverName.getUserName(), value);
    }

    public String getSenderName() {
        return senderName;
    }

    public String getReceiverName() {
        return receiverName;
    }

    public int getValue() {
        return value;
    }

    @Override
    public String toString() {
        return "Transaction{" +
                "senderName='" + senderName + '\'' +
                ", receiverName='" + receiverName + '\'' +
                ", value=" + value +
                '}';
    }

    //TODO InteliJ meint eine abfrage ob das Objekt null sei ist nicht wichtig.
    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Transaction) || obj == null) {
            return false;
        }
//        if (!(((Transaction) obj).getReceiverName().equals(getReceiverName()))) {
//            return false;
//        }
//        if (!(((Transaction) obj).getSenderName().equals(getSenderName()))) {
//            return false;
//        }
//        if (((Transaction) obj).getValue() != getValue()) {
//            return false;
//        }
        return true;
    }
}
